package lib;

class Rect {
	private final tl:Pos;
	private final br:Pos;

	public function new(p1:Pos, p2:Pos) {
		this.tl = {
			x: MathI.min(p1.x, p2.x),
			y: MathI.min(p1.y, p2.y)
		};

		this.br = {
			x: MathI.max(p1.x, p2.x),
			y: MathI.max(p1.y, p2.y)
		};
	}

	public function getSize():Int {
		return getWidth() * getHight();
	}

	public function isInside(p:Pos):Bool {
		return (p.x >= tl.x && p.x <= br.x) && (p.y >= tl.y && p.y <= br.y);
	}

	public function isOutside(p:Pos):Bool {
		return !this.isInside(p);
	}

	public function getHight():Int {
		return br.y - tl.y;
	}

	public function getWidth():Int {
		return br.x - tl.x;
	}

	public function offset(pos:Pos) {
		tl.x += pos.x;
		tl.y += pos.y;
		br.x += pos.x;
		br.y += pos.y;
	}
}
